unit SSLServerMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  ScTypes, ScBridge, ScTCPServer, ScSSLServer, ScSSLClient;

type
  TSSLServerForm = class(TForm)
    ScSSLServer: TScSSLServer;
    ScFileStorage: TScFileStorage;
    btRun: TButton;
    ScSSLClient: TScSSLClient;
    btTest: TButton;
    procedure btRunClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScSSLServerAfterSessionConnect(Sender: TObject;
      ServerConnection: TScSSLServerConnection);
    procedure btTestClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SSLServerForm: TSSLServerForm;

implementation

{$R *.dfm}

procedure TSSLServerForm.FormCreate(Sender: TObject);
begin
  ScFileStorage.Certificates.CertificateByName('ca').Key.Assign(ScFileStorage.Keys.KeyByName('ca'));
  ScFileStorage.Certificates.CertificateByName('server').Key.Assign(ScFileStorage.Keys.KeyByName('server'));
end;

procedure TSSLServerForm.FormDestroy(Sender: TObject);
begin
  ScSSLServer.Stop;
end;

procedure TSSLServerForm.btRunClick(Sender: TObject);
begin
  if ScSSLServer.Active then begin
    ScSSLServer.Stop;
    btRun.Caption := 'Start server';
  end
  else begin
    ScSSLServer.Start;
    btRun.Caption := 'Stop server';
  end;
end;

procedure TSSLServerForm.ScSSLServerAfterSessionConnect(Sender: TObject;
  ServerConnection: TScSSLServerConnection);
var
  Buf: TBytes;
begin
  // In this envet handler, you should implement all work with the SSL session

  SetLength(Buf, 10);
  ServerConnection.WriteBuffer(Buf, 0, Length(Buf));
end;

procedure TSSLServerForm.btTestClick(Sender: TObject);
var
  Buf: TBytes;
begin
  ScSSLClient.Connect;
  ScSSLClient.IsSecure := True;

  SetLength(Buf, 10);
  ScSSLClient.ReadBuffer(Buf, 0, Length(Buf));
end;

end.
